diff -x asm -Naur linux-2.4.30-orig/arch/mips/Makefile linux-2.4.30/arch/mips/Makefile
--- linux-2.4.30-orig/arch/mips/Makefile	2005-05-12 18:01:29.000000000 +0200
+++ linux-2.4.30/arch/mips/Makefile	2006-12-11 18:18:37.000000000 +0100
@@ -17,8 +17,8 @@
 # Select the object file format to substitute into the linker script.
 #
 ifdef CONFIG_CPU_LITTLE_ENDIAN
-#tool-prefix	= mipsel-linux-
-tool-prefix	= mips_nfp_le-
+tool-prefix     = mipsel-linux-
+#tool-prefix	= mips_nfp_le-
 ld-emul		= elf32ltsmip
 else
 tool-prefix	= mips-linux-
@@ -258,6 +258,13 @@
 LOADADDR      += 0x80100000
 endif
 
+ifdef CONFIG_MIPS_I3_MMB3
+LIBS          += arch/mips/au1000/db1x00/db1x00.o \
+                 arch/mips/au1000/common/au1000.o
+SUBDIRS       += arch/mips/au1000/db1x00 arch/mips/au1000/common
+LOADADDR      += 0x80100000
+endif
+
 ifdef CONFIG_MIPS_DB1100
 LIBS          += arch/mips/au1000/db1x00/db1x00.o \
                  arch/mips/au1000/common/au1000.o
diff -x asm -Naur linux-2.4.30-orig/arch/mips/au1000/common/dbdma.c linux-2.4.30/arch/mips/au1000/common/dbdma.c
--- linux-2.4.30-orig/arch/mips/au1000/common/dbdma.c	2005-05-12 17:57:05.000000000 +0200
+++ linux-2.4.30/arch/mips/au1000/common/dbdma.c	2006-12-11 18:18:37.000000000 +0100
@@ -209,10 +209,6 @@
  		p->dev_id = DSCR_DEV2CUSTOM_ID(new_id,dev->dev_id);
 		ret = p->dev_id;
 		new_id++;
-#if 0
-		printk("add_device: id:%x flags:%x padd:%x\n", 
-				p->dev_id, p->dev_flags, p->dev_physaddr );
-#endif
 	}
 
 	return ret;
@@ -316,6 +312,10 @@
 			if ((stp->dev_flags & DEV_FLAGS_SYNC) ||
 				(dtp->dev_flags & DEV_FLAGS_SYNC))
 					i |= DDMA_CFG_SYNC;
+#if defined(CONFIG_NONCOHERENT_IO)
+                        // DBDMA reads descriptors non-coherently
+                        i |= DDMA_CFG_DFN;
+#endif
 			cp->ddma_cfg = i;
 			au_sync();
 
@@ -337,9 +337,9 @@
 
 /* Set the device width if source or destination is a FIFO.
  * Should be 8, 16, or 32 bits.
+ * The membits is added. If = 0 => no change.
  */
-u32
-au1xxx_dbdma_set_devwidth(u32 chanid, int bits)
+u32 _au1xxx_dbdma_set_devwidth(u32 chanid, u32 iobits, u32 membits)
 {
 	u32		rv;
 	chan_tab_t	*ctp;
@@ -352,16 +352,45 @@
 
 	if (stp->dev_flags & DEV_FLAGS_IN) {	/* Source in fifo */
 		rv = stp->dev_devwidth;
-		stp->dev_devwidth = bits;
+		stp->dev_devwidth = iobits;
+		if (membits)
+		  dtp->dev_devwidth = membits;
 	}
 	if (dtp->dev_flags & DEV_FLAGS_OUT) {	/* Destination out fifo */
 		rv = dtp->dev_devwidth;
-		dtp->dev_devwidth = bits;
+		dtp->dev_devwidth = iobits;
+		if (membits)
+		  stp->dev_devwidth = membits;
 	}
 
 	return rv;
 }
-EXPORT_SYMBOL(au1xxx_dbdma_set_devwidth);
+EXPORT_SYMBOL(_au1xxx_dbdma_set_devwidth);
+
+/* Set the transfer size of the data structure for src1 and dest1.
+ * return value = ((src_datums << 16) | dest_datums);
+ * This function should be called before au1xxx_dbdma_ring_alloc()
+ */
+u32
+_au1xxx_dbdma_set_transfer_size(u32 chanid, u32 src_datums, u32 dest_datums)
+{
+	u32		rv = 0;
+	chan_tab_t	*ctp;
+	dbdev_tab_t	*stp, *dtp;
+
+	ctp = *((chan_tab_t **)chanid);
+	if (ctp == NULL) return 0;
+
+	stp = ctp->chan_src;
+	dtp = ctp->chan_dest;
+
+	rv = stp->dev_tsize = src_datums;
+	dtp->dev_tsize = dest_datums;
+	rv <<= 16;
+	rv |= dest_datums;
+	return rv;	
+}
+EXPORT_SYMBOL(_au1xxx_dbdma_set_transfer_size);
 
 /* Allocate a descriptor ring, initializing as much as possible.
 */
@@ -375,6 +404,7 @@
 	chan_tab_t		*ctp;
 	dbdev_tab_t		*stp, *dtp;
 	au1x_ddma_desc_t	*dp;
+	au1x_dma_chan_t		*cp;
 
 	/* I guess we could check this to be within the
 	 * range of the table......
@@ -382,6 +412,7 @@
 	ctp = *((chan_tab_t **)chanid);
 	stp = ctp->chan_src;
 	dtp = ctp->chan_dest;
+	cp = ctp->chan_ptr;
 
 	/* The descriptors must be 32-byte aligned.  There is a
 	 * possibility the allocation will give us such an address,
@@ -422,7 +453,8 @@
 	cmd0 |= DSCR_CMD0_SID(srcid);
 	cmd0 |= DSCR_CMD0_DID(destid);
 	cmd0 |= DSCR_CMD0_IE | DSCR_CMD0_CV;
-	cmd0 |= DSCR_CMD0_ST(DSCR_CMD0_ST_CURRENT);
+	//	cmd0 |= DSCR_CMD0_ST(DSCR_CMD0_ST_CURRENT);
+	cmd0 |= DSCR_CMD0_ST(DSCR_CMD0_ST_NOCHANGE);
 
 	switch (stp->dev_devwidth) {
 	case 8:
@@ -458,6 +490,11 @@
 	if (dtp->dev_flags & DEV_FLAGS_OUT)
 		cmd0 |= DSCR_CMD0_DN;		/* Destination out fifo */
 
+#ifdef KC_HACK
+	/* set as higer priority */
+	cmd0 |= DSCR_CMD0_ARB;
+#endif
+
 	/* Set up source1.  For now, assume no stride and increment.
 	 * A channel attribute update can change this later.
 	 */
@@ -472,9 +509,11 @@
 		src1 |= DSCR_SRC1_STS(DSCR_xTS_SIZE4);
 		break;
 	case 8:
-	default:
 		src1 |= DSCR_SRC1_STS(DSCR_xTS_SIZE8);
 		break;
+	default:
+		src1 |= DSCR_SRC1_STS(DSCR_xTS_SIZE1);
+		break;
 	}
 
 	/* If source input is fifo, set static address.
@@ -503,9 +542,11 @@
 		dest1 |= DSCR_DEST1_DTS(DSCR_xTS_SIZE4);
 		break;
 	case 8:
-	default:
 		dest1 |= DSCR_DEST1_DTS(DSCR_xTS_SIZE8);
 		break;
+	default:
+		dest1 |= DSCR_DEST1_DTS(DSCR_xTS_SIZE1);
+		break;
 	}
 
 	/* If destination output is fifo, set static address.
@@ -513,16 +554,12 @@
 	if (dtp->dev_flags & DEV_FLAGS_OUT) {
 		if ( dtp->dev_flags & DEV_FLAGS_BURSTABLE )
 	                dest1 |= DSCR_DEST1_DAM(DSCR_xAM_BURST);
-				else
+		else
 		dest1 |= DSCR_DEST1_DAM(DSCR_xAM_STATIC);
 	}
 	if (dtp->dev_physaddr) 
 		dest0 = dtp->dev_physaddr;
 	
-#if 0
-		printk("did:%x sid:%x cmd0:%x cmd1:%x source0:%x source1:%x dest0:%x dest1:%x\n",
-			dtp->dev_id, stp->dev_id, cmd0, cmd1, src0, src1, dest0, dest1 );
-#endif
 	for (i=0; i<entries; i++) {
 		dp->dscr_cmd0 = cmd0;
 		dp->dscr_cmd1 = cmd1;
@@ -531,8 +568,11 @@
 		dp->dscr_dest0 = dest0;
 		dp->dscr_dest1 = dest1;
 		dp->dscr_stat = 0;
-				dp->sw_context = dp->sw_status = 0;
 		dp->dscr_nxtptr = DSCR_NXTPTR(virt_to_phys(dp + 1));
+#if defined(CONFIG_NONCOHERENT_IO)
+		au_sync();
+		dma_cache_wback_inv((unsigned long)dp, (unsigned long)sizeof(au1x_ddma_desc_t));
+#endif
 		dp++;
 	}
 	
@@ -540,7 +580,14 @@
 	*/
 	dp--;
 	dp->dscr_nxtptr = DSCR_NXTPTR(virt_to_phys(ctp->chan_desc_base));
-	ctp->get_ptr = ctp->put_ptr = ctp->cur_ptr = ctp->chan_desc_base;
+#if defined(CONFIG_NONCOHERENT_IO)
+	au_sync();
+	dma_cache_wback_inv((unsigned long)dp, (unsigned long)sizeof(au1x_ddma_desc_t));
+#endif
+	ctp->ptr = ctp->chan_desc_base;
+	cp->ddma_desptr = virt_to_phys(ctp->chan_desc_base);
+
+	au_sync();
 
 	return (u32)(ctp->chan_desc_base);
 }
@@ -565,7 +612,10 @@
 	 * an interrupt doesn't affect this pointer nor the descriptor,
 	 * so no locking should be needed.
 	 */
-	dp = ctp->put_ptr;
+	dp = ctp->ptr;
+#if defined(CONFIG_NONCOHERENT_IO)
+	dma_cache_inv((unsigned long)dp, (unsigned long)sizeof(au1x_ddma_desc_t));
+#endif
 
 	/* If the descriptor is valid, we are way ahead of the DMA
 	 * engine, so just return an error condition.
@@ -573,11 +623,13 @@
 	if (dp->dscr_cmd0 & DSCR_CMD0_V) {
 		return 0;
 	}
-	
+
 	/* Load up buffer address and byte count.
 	*/
 	dp->dscr_source0 = virt_to_phys(buf);
-	dp->dscr_cmd1 = nbytes;
+	dp->dscr_cmd1 &= ~(0x3fffff);
+	dp->dscr_cmd1 |= nbytes;
+
 	/* Check flags  */
 	if (flags & DDMA_FLAGS_IE) 
 		dp->dscr_cmd0 |= DSCR_CMD0_IE;
@@ -585,7 +637,7 @@
 		dp->dscr_cmd0 &= ~DSCR_CMD0_IE;
 	/* Get next descriptor pointer.
 	*/
-	ctp->put_ptr = phys_to_virt(DSCR_GET_NXTPTR(dp->dscr_nxtptr));
+	ctp->ptr = phys_to_virt(DSCR_GET_NXTPTR(dp->dscr_nxtptr));
 
 	/*
 	 * There is an errata on the Au1200/Au1550 parts that could result 
@@ -594,11 +646,17 @@
 	 * these parts. If it is fixedin the future, these dma_cache_inv will 
 	 * just be nothing more than empty macros. See io.h.
 	 * */
-	dma_cache_wback_inv(buf,nbytes);
+	au_sync();
+#if defined(CONFIG_NONCOHERENT_IO)
+	dma_cache_wback_inv((unsigned long)buf, (unsigned long)nbytes);
+#endif
         dp->dscr_cmd0 |= DSCR_CMD0_V;        /* Let it rip */
+#if defined(CONFIG_NONCOHERENT_IO)
 	au_sync();
-	dma_cache_wback_inv(dp, sizeof(dp));
+	dma_cache_wback_inv((unsigned long)dp, (unsigned long)sizeof(au1x_ddma_desc_t));
+#endif
         ctp->chan_ptr->ddma_dbell = 0;
+	au_sync();
 
 	/* return something not zero.
 	*/
@@ -625,7 +683,10 @@
 	 * an interrupt doesn't affect this pointer nor the descriptor,
 	 * so no locking should be needed.
 	 */
-	dp = ctp->put_ptr;
+	dp = ctp->ptr;
+#if defined(CONFIG_NONCOHERENT_IO)
+	dma_cache_inv((unsigned long)dp, (unsigned long)sizeof(au1x_ddma_desc_t));
+#endif
 
 	/* If the descriptor is valid, we are way ahead of the DMA
 	 * engine, so just return an error condition.
@@ -642,12 +703,9 @@
 		dp->dscr_cmd0 &= ~DSCR_CMD0_IE;
 
 	dp->dscr_dest0 = virt_to_phys(buf);
-	dp->dscr_cmd1 = nbytes;
-#if 0
-	printk("cmd0:%x cmd1:%x source0:%x source1:%x dest0:%x dest1:%x\n", 
-			dp->dscr_cmd0, dp->dscr_cmd1, dp->dscr_source0, 
-			dp->dscr_source1, dp->dscr_dest0, dp->dscr_dest1 );
-#endif
+	dp->dscr_cmd1 &= ~(0x3fffff);
+	dp->dscr_cmd1 |= nbytes;
+
 	/*
 	 * There is an errata on the Au1200/Au1550 parts that could result in 
 	 * "stale" data being DMA'd. It has to do with the snoop logic on the 
@@ -655,15 +713,22 @@
 	 * parts. If it is fixedin the future, these dma_cache_inv will just 
 	 * be nothing more than empty macros. See io.h. 
 	 * */
-	dma_cache_inv(buf,nbytes);
+#if defined(CONFIG_NONCOHERENT_IO)
+        // Need to do a wback since there may be other data sharing the same cache line
+        // as buf.
+	dma_cache_wback_inv((unsigned long)buf,(unsigned long)nbytes);
+#endif
 	dp->dscr_cmd0 |= DSCR_CMD0_V;	/* Let it rip */
+#if defined(CONFIG_NONCOHERENT_IO)
 	au_sync();
-	dma_cache_wback_inv(dp, sizeof(dp));
+	dma_cache_wback_inv((unsigned long)dp, (unsigned long)sizeof(au1x_ddma_desc_t));
+#endif
         ctp->chan_ptr->ddma_dbell = 0;
-	
+	au_sync();
+
 	/* Get next descriptor pointer.
 	*/
-	ctp->put_ptr = phys_to_virt(DSCR_GET_NXTPTR(dp->dscr_nxtptr));
+	ctp->ptr = phys_to_virt(DSCR_GET_NXTPTR(dp->dscr_nxtptr));
 
 	/* return something not zero.
 	*/
@@ -692,7 +757,10 @@
 	 * an interrupt doesn't affect this pointer nor the descriptor,
 	 * so no locking should be needed.
 	 */
-	dp = ctp->get_ptr;
+	dp = ctp->ptr;
+#if defined(CONFIG_NONCOHERENT_IO)
+	dma_cache_inv((unsigned long)dp, (unsigned long)sizeof(au1x_ddma_desc_t));
+#endif
 
 	/* If the descriptor is valid, we are way ahead of the DMA
 	 * engine, so just return an error condition.
@@ -708,7 +776,7 @@
 	
 	/* Get next descriptor pointer.
 	*/
-	ctp->get_ptr = phys_to_virt(DSCR_GET_NXTPTR(dp->dscr_nxtptr));
+	ctp->ptr = phys_to_virt(DSCR_GET_NXTPTR(dp->dscr_nxtptr));
 
 	/* return something not zero.
 	*/
@@ -753,7 +821,6 @@
 
 	ctp = *((chan_tab_t **)chanid);
 	cp = ctp->chan_ptr;
-	cp->ddma_desptr = virt_to_phys(ctp->cur_ptr);
 	cp->ddma_cfg |= DDMA_CFG_EN;	/* Enable channel */
 	au_sync();
 	cp->ddma_dbell = 0;
@@ -765,12 +832,16 @@
 au1xxx_dbdma_reset(u32 chanid)
 {
 	chan_tab_t		*ctp;
+	au1x_dma_chan_t		*cp;
 	au1x_ddma_desc_t	*dp;
 
 	au1xxx_dbdma_stop(chanid);
 
 	ctp = *((chan_tab_t **)chanid);
-	ctp->get_ptr = ctp->put_ptr = ctp->cur_ptr = ctp->chan_desc_base;
+	cp = ctp->chan_ptr;
+	ctp->ptr = ctp->chan_desc_base;
+	cp->ddma_desptr = virt_to_phys(ctp->chan_desc_base);
+	au_sync();
 
 	/* Run through the descriptors and reset the valid indicator.
 	*/
@@ -778,13 +849,18 @@
 
 	do {
 		dp->dscr_cmd0 &= ~DSCR_CMD0_V;
+		/* want to save the D-cache!! */
 		/* reset our SW status -- this is used to determine 
 		 * if a descriptor is in use by upper level SW. Since 
 		 * posting can reset 'V' bit. 
 		 */
-		dp->sw_status = 0;
+#if defined(CONFIG_NONCOHERENT_IO)
+		au_sync();
+		dma_cache_wback_inv((unsigned long)dp, (unsigned long)sizeof(au1x_ddma_desc_t));
+#endif
 		dp = phys_to_virt(DSCR_GET_NXTPTR(dp->dscr_nxtptr));
 	} while (dp != ctp->chan_desc_base);
+	au_sync();
 }
 EXPORT_SYMBOL(au1xxx_dbdma_reset);
 
@@ -819,7 +895,7 @@
 	au1xxx_dbdma_stop(chanid);
 
 	if (ctp->chan_desc_base != NULL)
-		kfree(ctp->chan_desc_base);
+		kfree((const void *)ctp->chan_desc_base);
 	
 	stp->dev_flags &= ~DEV_FLAGS_INUSE;
 	dtp->dev_flags &= ~DEV_FLAGS_INUSE;
@@ -832,19 +908,21 @@
 static void
 dbdma_interrupt(int irq, void *dev_id, struct pt_regs *regs)
 {
-	u32        				intstat, flags;
+	u32	intstat;
 	u32	chan_index;
 	chan_tab_t		*ctp;
-	au1x_ddma_desc_t	*dp;
 	au1x_dma_chan_t *cp;
 
+	if(!dbdma_initialized) {
+	    panic("dbdma: Got interrupt before initialized\n.");
+	}
+
 	intstat = dbdma_gptr->ddma_intstat;
 	au_sync();
 	chan_index = au_ffs(intstat) - 1;
 
 	ctp = chan_tab_ptr[chan_index];
 	cp = ctp->chan_ptr;
-	dp = ctp->cur_ptr;
 
 	/* Reset interrupt.
 	*/
@@ -854,7 +932,6 @@
 	if (ctp->chan_callback)
 		(ctp->chan_callback)(irq, ctp->chan_callparam, regs);
 
-	ctp->cur_ptr = phys_to_virt(DSCR_GET_NXTPTR(dp->dscr_nxtptr));
 }
 
 static void au1xxx_dbdma_init(void)
@@ -895,9 +972,8 @@
 
 	printk("Chan %x, stp %x (dev %d)  dtp %x (dev %d) \n",
 		(u32)ctp, (u32)stp, stp - dbdev_tab, (u32)dtp, dtp - dbdev_tab);
-	printk("desc base %x, get %x, put %x, cur %x\n",
-		(u32)(ctp->chan_desc_base), (u32)(ctp->get_ptr),
-		(u32)(ctp->put_ptr), (u32)(ctp->cur_ptr));
+	printk("desc base %x, ptr %x\n",
+	       (u32)(ctp->chan_desc_base), (u32)(ctp->ptr));
 	
 	printk("dbdma chan %x\n", (u32)cp);
 	printk("cfg %08x, desptr %08x, statptr %08x\n",
@@ -920,6 +996,7 @@
 		dp = phys_to_virt(DSCR_GET_NXTPTR(dp->dscr_nxtptr));
 	} while (dp != ctp->chan_desc_base);
 }
+EXPORT_SYMBOL(au1xxx_dbdma_dump);
 
 /* Put a descriptor into the DMA ring.
  * This updates the source/destination pointers and byte count.
@@ -940,7 +1017,10 @@
 	* an interrupt doesn't affect this pointer nor the descriptor,
 	* so no locking should be needed.
 	*/
-	dp = ctp->put_ptr;
+	dp = ctp->ptr;
+#if defined(CONFIG_NONCOHERENT_IO)
+	dma_cache_inv((unsigned long)dp, (unsigned long)sizeof(au1x_ddma_desc_t));
+#endif
 
 	/* If the descriptor is valid, we are way ahead of the DMA
 	* engine, so just return an error condition.
@@ -959,16 +1039,76 @@
 	/* Allow the caller to specifiy if an interrupt is generated */
 	dp->dscr_cmd0 &= ~DSCR_CMD0_IE;
 	dp->dscr_cmd0 |= dscr->dscr_cmd0 | DSCR_CMD0_V;
+#if defined(CONFIG_NONCOHERENT_IO)
+	au_sync();
+	dma_cache_wback_inv((unsigned long)dp, (unsigned long)sizeof(au1x_ddma_desc_t));
+#endif
 	ctp->chan_ptr->ddma_dbell = 0;
+	au_sync();
 
 	/* Get next descriptor pointer.
 	*/
-	ctp->put_ptr = phys_to_virt(DSCR_GET_NXTPTR(dp->dscr_nxtptr));
+	ctp->ptr = phys_to_virt(DSCR_GET_NXTPTR(dp->dscr_nxtptr));
 
 	/* return something not zero.
 	*/
 	return nbytes;
 }
 
+/* Put a descriptor into the DMA ring.
+ * This updates the byte count only.  Normally during fifo to fifo
+ * transfers. 
+ */
+u32
+au1xxx_dbdma_put_dscr2(u32 chanid, int nbytes)
+{
+        chan_tab_t              *ctp;
+        au1x_ddma_desc_t        *dp;
+
+        /* I guess we could check this to be within the
+         * range of the table......
+         */
+        ctp = *((chan_tab_t **)chanid);
+
+        /* We should have multiple callers for a particular channel,
+         * an interrupt doesn't affect this pointer nor the descriptor,
+         * so no locking should be needed.
+         */
+        dp = ctp->ptr;
+#if defined(CONFIG_NONCOHERENT_IO)
+	dma_cache_inv((unsigned long)dp, (unsigned long)sizeof(au1x_ddma_desc_t));
+#endif
+
+        /* If the descriptor is valid, we are way ahead of the DMA
+         * engine, so just return an error condition.
+         */
+        if (dp->dscr_cmd0 & DSCR_CMD0_V)
+                return 0;
+
+        // Set ddma_irq upon descriptor completion
+        dp->dscr_cmd0 |= DSCR_CMD0_IE;
+
+        // Update length
+        dp->dscr_cmd1 = nbytes;
+
+        dp->dscr_cmd0 |= DSCR_CMD0_V;        /* Let it rip */
+#if defined(CONFIG_NONCOHERENT_IO)
+	au_sync();
+        dma_cache_wback_inv((unsigned long)dp, (unsigned long)sizeof(au1x_ddma_desc_t));
+#endif
+
+        ctp->chan_ptr->ddma_dbell = 0;
+        au_sync();
+        
+        /* Get next descriptor pointer.
+         */
+        ctp->ptr = phys_to_virt(DSCR_GET_NXTPTR(dp->dscr_nxtptr));
+
+        /* return something not zero.
+         */
+        return nbytes;
+}
+EXPORT_SYMBOL(au1xxx_dbdma_put_dscr2);
+
 #endif /* defined(CONFIG_SOC_AU1550) || defined(CONFIG_SOC_AU1200) */
 
diff -x asm -Naur linux-2.4.30-orig/arch/mips/au1000/common/reset.c linux-2.4.30/arch/mips/au1000/common/reset.c
--- linux-2.4.30-orig/arch/mips/au1000/common/reset.c	2005-05-12 17:57:05.000000000 +0200
+++ linux-2.4.30/arch/mips/au1000/common/reset.c	2006-12-11 18:18:37.000000000 +0100
@@ -37,6 +37,32 @@
 #include <asm/system.h>
 #include <asm/au1000.h>
 
+/* Paranoid reset of dbdma
+ */
+static void reset_dbdma(void)
+{
+    int i;
+
+    /* Reset each channel
+     */
+    for(i = 0; i < 16; i++) {
+	au_writel(0, 0xb4002000 + 0x100*i + 0x00); /* cfg */
+	au_writel(0, 0xb4002000 + 0x100*i + 0x04); /* desptr */
+	au_writel(0, 0xb4002000 + 0x100*i + 0x08); /* statptr */
+	au_writel(0, 0xb4002000 + 0x100*i + 0x0c); /* dbell */
+	au_writel(0, 0xb4002000 + 0x100*i + 0x10); /* interrupt request */
+	au_writel(1, 0xb4002000 + 0x100*i + 0x14); /* status */
+	au_writel(0, 0xb4002000 + 0x100*i + 0x18); /* remaining byte count */
+    }
+
+    /* Reset global.
+     */
+    au_writel(0, 0xb4003000 + 0x00); /* config */
+    au_writel(0, 0xb4003000 + 0x00); /* intstat */
+    au_writel(0, 0xb4003000 + 0x00); /* throttle */
+    au_writel(0, 0xb4003000 + 0x00); /* inten */
+}
+
 void au1000_restart(char *command)
 {
 	/* Set all integrated peripherals to disabled states */
@@ -120,6 +146,16 @@
 		au_writel(0x00, 0xb1900100); /* sys_pininputen */
 		break;
 	case 0x03000000: /* Au1550 */
+#ifdef CONFIG_MIPS_I3_MMB3
+		au_writel(0x00, MEM_STADDR3);
+		au_writel(0x00, MEM_STTIME3);
+		au_writel(0x00, MEM_STCFG3);
+		asm("sync");
+		/* This delay is unfortunately necessary
+		 * could possibly be solved by enabling IDE drive reset
+		 */
+		udelay(10);
+#endif
 		au_writel(0x00, 0xb1a00004); /* psc 0 */
 		au_writel(0x00, 0xb1b00004); /* psc 1 */
 		au_writel(0x00, 0xb0a00004); /* psc 2 */
@@ -141,6 +177,7 @@
 		au_writel(0x10, 0xb1900060); /* sys_cpupll */
 		au_writel(0x00, 0xb1900064); /* sys_auxpll */
 		au_writel(0x00, 0xb1900100); /* sys_pininputen */
+		reset_dbdma();
 		break;
 	case 0x04000000: /* Au1200 */
 		au_writel(0x00, 0xb400300c); /* ddma */
diff -x asm -Naur linux-2.4.30-orig/arch/mips/au1000/common/time.c linux-2.4.30/arch/mips/au1000/common/time.c
--- linux-2.4.30-orig/arch/mips/au1000/common/time.c	2005-05-12 18:01:29.000000000 +0200
+++ linux-2.4.30/arch/mips/au1000/common/time.c	2006-12-11 18:18:37.000000000 +0100
@@ -560,5 +560,5 @@
 	/* Determine CP0 timer values */
 	printk("calculating r4koff... ");
 	r4k_offset = cal_r4koff();
-	printk("%08lx(%d)\n", r4k_offset, (int) r4k_offset);
+	printk("%08x(%d)\n", r4k_offset, (int) r4k_offset);
 }
diff -x asm -Naur linux-2.4.30-orig/arch/mips/au1000/db1x00/board_setup.c linux-2.4.30/arch/mips/au1000/db1x00/board_setup.c
--- linux-2.4.30-orig/arch/mips/au1000/db1x00/board_setup.c	2005-05-12 17:57:05.000000000 +0200
+++ linux-2.4.30/arch/mips/au1000/db1x00/board_setup.c	2006-12-11 18:18:37.000000000 +0100
@@ -46,6 +46,7 @@
 #include <asm/au1000.h>
 #include <asm/db1x00.h>
 
+#if 0
 #if defined(CONFIG_BLK_DEV_IDE_AU1XXX) && defined(CONFIG_MIPS_DB1550)
 #include <asm/au1xxx_dbdma.h>
 extern struct ide_ops *ide_ops;
@@ -60,13 +61,16 @@
 
 dbdev_tab_t new_dbdev_tab_element = { DSCR_CMD0_THROTTLE, DEV_FLAGS_ANYUSE, 0, 0, 0x00000000, 0, 0 };
 #endif /* end CONFIG_BLK_DEV_IDE_AU1XXX */
+#endif
 
 extern struct rtc_ops no_rtc_ops;
 
 void board_reset (void)
 {
+#ifndef CONFIG_MIPS_I3_MMB3
 	/* Hit BCSR.SYSTEM_CONTROL[SW_RST] */
 	au_writel(0x00000000, 0xAE00001C);
+#endif
 }
 
 void board_power_off (void)
@@ -78,7 +82,7 @@
 
 void __init board_setup(void)
 {
-	u32 pin_func;
+  //	u32 pin_func;
 
 	rtc_ops = &no_rtc_ops;
 
@@ -98,7 +102,10 @@
 	bcsr->resets |= BCSR_RESETS_IRDA_MODE_OFF;
 	au_sync();
 #endif
+
+#ifndef CONFIG_MIPS_I3_MMB3
 	au_writel(0, 0xAE000010); /* turn off pcmcia power */
+#endif
 
 #ifdef CONFIG_MIPS_MIRAGE
 	/* enable GPIO[31:0] inputs */
@@ -126,41 +133,73 @@
 	au_writel(au_readl(GPIO2_DIR) | 0x200, GPIO2_DIR);
 	au_writel(0x02000200, GPIO2_OUTPUT);
 #endif
-
-#if defined(CONFIG_AU1XXX_SMC91111)
-#define CPLD_CONTROL (0xAF00000C)
 	{
-	extern uint32_t au1xxx_smc91111_base;
-	extern unsigned int au1xxx_smc91111_irq;
-	extern int au1xxx_smc91111_nowait;
-
-	au1xxx_smc91111_base = 0xAC000300;
-	au1xxx_smc91111_irq = AU1000_GPIO_8;
-	au1xxx_smc91111_nowait = 1;
-
-	/* set up the Static Bus timing - only 396Mhz */
-	bcsr->resets |= 0x7;
-	au_writel(0x00010003, MEM_STCFG0);
-	au_writel(0x000c00c0, MEM_STCFG2);
-	au_writel(0x85E1900D, MEM_STTIME2);
+		int config;
+		// S:0(async), BEB=2 (recommended), H:0 (32bit bus),
+#define ST3_IDE_NW	0
+#define ST3_IDE_AS	0
+#define ST3_IDE_S	0
+#define ST3_IDE_DE	0
+#define ST3_IDE_BEB	2 // not change it. working
+#define ST3_IDE_BE	0
+#define ST3_IDE_TS	0
+#define ST3_IDE_EW	0
+#define ST3_IDE_H	0 // 0 or 1 either works with 16-16, 8,8 datums.
+	    // 1 not work with 16-32, 8-4 datums
+#define ST3_IDE_BS	0 //ONLY for NAND mod 8 beats
+#define ST3_IDE_PM	0 //ONLY for NAND mod
+#define ST3_IDE_RO	0
+#define ST3_IDE_DTY	2 // not change it
+
+		// Codekti Au1550 IDE over the Static RAM
+		//	    AS=1, DE=1  BEB=2, H=1
+		config = ((ST3_IDE_NW << 22) | (ST3_IDE_AS << 21) | (ST3_IDE_S << 20) |   
+			  (ST3_IDE_DE << 19) | (ST3_IDE_BEB << 17) | (ST3_IDE_BE << 9) |
+			  (ST3_IDE_TS << 8) | (ST3_IDE_EW << 7) | (ST3_IDE_H << 6) |
+			  (ST3_IDE_BS << 5) | (ST3_IDE_PM << 4) | (ST3_IDE_RO << 3) |
+			  (ST3_IDE_DTY << 0));
+		au_writel(config, MEM_STCFG3); // = 0x00040002
 	}
-#endif /* end CONFIG_SMC91111 */
+	{
+		int timing;
+
+#if 0 // AMD_PATCH
+#define ST3_IDE_Tmst	0
+#define ST3_IDE_Tmsu	0
+#define ST3_IDE_Tmih	0
+#define ST3_IDE_Tist	7 // was 20
+#define ST3_IDE_Tisu	1
+#else
+// within the spec
+#define ST3_IDE_Tmst	0
+#define ST3_IDE_Tmsu	0
+#define ST3_IDE_Tmih	1
+#define ST3_IDE_Tist	10
+#define ST3_IDE_Tisu	3
+#endif
+		timing = ((ST3_IDE_Tmst << 24) | (ST3_IDE_Tmsu << 17) | (ST3_IDE_Tmih << 11) |
+			  (ST3_IDE_Tist << 5) | (ST3_IDE_Tisu << 0));
+        	au_writel(timing, MEM_STTIME3); // PIO 4, 16.67 MB/s, was 0x00000985
+        	//0x00000943
+        }
+
+	au_writel(0x10003fff, MEM_STADDR3); // Set mask
 	au_sync();
 
-#if defined(CONFIG_BLK_DEV_IDE_AU1XXX) && defined(CONFIG_MIPS_DB1550)
-	/*
-	 * Iniz IDE parameters
-	 */
-	ide_ops = &au1xxx_ide_ops;
-	au1xxx_ide_irq = DAUGHTER_CARD_IRQ;
-	au1xxx_ide_physbase = AU1XXX_ATA_PHYS_ADDR;
-	au1xxx_ide_virtbase = KSEG1ADDR(AU1XXX_ATA_PHYS_ADDR);
-
-	/*
-	 * change PIO or PIO+Ddma
-	 * check the GPIO-6 pin condition. db1550:s6_dot
-	 */
-	switch4ddma = (au_readl(SYS_PINSTATERD) & (1 << 6)) ? 1 : 0;
+#if defined(CONFIG_BLK_DEV_IDE_AU1XXX)
+ 	extern struct ide_ops *ide_ops;
+ 	extern struct ide_ops auide_ops;
+ 	extern void ide_register_driver(ide_driver_call);
+ 	extern int auide_probe (void);
+
+#if defined(CONFIG_BLK_DEV_IDE_PCMCIA_AU1XXX)
+#if defined(CONFIG_PCMCIA)
+#error "Please turn off CONFIG_PCMCIA"
+#endif
+//	pcmcia_setup_for_ide();
+#endif
+ 	ide_ops = &auide_ops;
+ 	ide_register_driver( auide_probe );
 #endif
 
 #ifdef CONFIG_MIPS_DB1000
@@ -181,4 +220,7 @@
 #ifdef CONFIG_MIPS_DB1550
     printk("AMD Alchemy Au1550/Db1550 Board\n");
 #endif
+#ifdef CONFIG_MIPS_I3_MMB3
+    printk("I3 Micro Technology Mood 300 STB\n");
+#endif
 }
diff -x asm -Naur linux-2.4.30-orig/arch/mips/au1000/db1x00/init.c linux-2.4.30/arch/mips/au1000/db1x00/init.c
--- linux-2.4.30-orig/arch/mips/au1000/db1x00/init.c	2005-05-12 17:57:05.000000000 +0200
+++ linux-2.4.30/arch/mips/au1000/db1x00/init.c	2006-12-11 18:18:37.000000000 +0100
@@ -48,6 +48,8 @@
 {
 #ifdef CONFIG_MIPS_BOSPORUS
 	return "Alchemy Bosporus Gateway Reference";
+#elif defined CONFIG_MIPS_I3_MMB3
+	return "i3 Mood Series 300";
 #else
 	return "Alchemy Db1x00";
 #endif
diff -x asm -Naur linux-2.4.30-orig/arch/mips/au1000/db1x00/irqmap.c linux-2.4.30/arch/mips/au1000/db1x00/irqmap.c
--- linux-2.4.30-orig/arch/mips/au1000/db1x00/irqmap.c	2005-05-12 17:57:05.000000000 +0200
+++ linux-2.4.30/arch/mips/au1000/db1x00/irqmap.c	2006-12-11 18:18:37.000000000 +0100
@@ -50,9 +50,10 @@
 au1xxx_irq_map_t au1xxx_irq_map[] = {
 
 #ifndef CONFIG_MIPS_MIRAGE
-#ifdef CONFIG_MIPS_DB1550
+#if defined(CONFIG_MIPS_DB1550) || defined(CONFIG_MIPS_I3_MMB3)
 	{ AU1000_GPIO_3, INTC_INT_LOW_LEVEL, 0 }, // PCMCIA Card 0 IRQ#
 	{ AU1000_GPIO_5, INTC_INT_LOW_LEVEL, 0 }, // PCMCIA Card 1 IRQ#
+	{ AU1500_GPIO_207, INTC_INT_HIGH_LEVEL, 0 },
 	{ AU1000_GPIO_8, INTC_INT_LOW_LEVEL, 0 }, // Daughtercard IRQ#
 #else
 	{ AU1000_GPIO_0, INTC_INT_LOW_LEVEL, 0 }, // PCMCIA Card 0 Fully_Interted#
@@ -79,7 +80,7 @@
 #define INTD AU1000_PCI_INTD
 #endif
 
-#ifdef CONFIG_SOC_AU1550
+#if defined(CONFIG_SOC_AU1550) || defined(CONFIG_MIPS_I3_MMB3)
 #define INTA AU1550_PCI_INTA
 #define INTB AU1550_PCI_INTB
 #define INTC AU1550_PCI_INTC
@@ -133,6 +134,23 @@
 	};
 	const long min_idsel = 11, max_idsel = 13, irqs_per_slot = 4;
 #endif
+
+#ifdef CONFIG_MIPS_I3_MMB3
+	static char pci_irq_table[][4] =
+	{
+		{INTA, INTX, INTX, INTX},   /* IDSEL  5 - on-board TI 642    */
+		{INTX, INTX, INTX, INTX},   /* IDSEL  6 - unused             */
+		{INTX, INTX, INTX, INTX},   /* IDSEL  7 - unused             */
+		{INTX, INTX, INTX, INTX},   /* IDSEL  8 - unused             */
+		{INTX, INTX, INTX, INTX},   /* IDSEL  9 - unused             */
+		{INTX, INTX, INTX, INTX},   /* IDSEL 10 - unused             */
+		{INTC, INTX, INTX, INTX},   /* IDSEL 11 - on-board HPT371    */
+		{INTB, INTC, INTD, INTA},   /* IDSEL 12 - PCI slot 2 (left)  */
+		{INTA, INTB, INTC, INTD},   /* IDSEL 13 - PCI slot 1 (right) */
+	};
+	const long min_idsel = 5, max_idsel = 13, irqs_per_slot = 4;
+#endif
+
 #if defined(CONFIG_SOC_AU1550) || defined(CONFIG_SOC_AU1500)
 	return PCI_IRQ_TABLE_LOOKUP;
 #else
diff -x asm -Naur linux-2.4.30-orig/arch/mips/config-shared.in linux-2.4.30/arch/mips/config-shared.in
--- linux-2.4.30-orig/arch/mips/config-shared.in	2005-05-12 18:01:29.000000000 +0200
+++ linux-2.4.30/arch/mips/config-shared.in	2006-12-11 18:18:37.000000000 +0100
@@ -27,6 +27,7 @@
 dep_bool 'Support for Alchemy Db1100 board' CONFIG_MIPS_DB1100 $CONFIG_MIPS32
 dep_bool 'Support for Alchemy Db1500 board' CONFIG_MIPS_DB1500 $CONFIG_MIPS32
 dep_bool 'Support for Alchemy Db1550 board' CONFIG_MIPS_DB1550 $CONFIG_MIPS32
+dep_bool 'Support for I3 Micro MMB3 board'  CONFIG_MIPS_I3_MMB3 $CONFIG_MIPS32
 dep_bool 'Support for Alchemy Db1200 board' CONFIG_MIPS_DB1200 $CONFIG_MIPS32
 dep_bool 'Support for Alchemy PB1000 board' CONFIG_MIPS_PB1000 $CONFIG_MIPS32
 dep_bool 'Support for Alchemy PB1100 board' CONFIG_MIPS_PB1100 $CONFIG_MIPS32
@@ -334,6 +335,13 @@
    define_bool CONFIG_NONCOHERENT_IO y
    define_bool CONFIG_PC_KEYB y
 fi
+if [ "$CONFIG_MIPS_I3_MMB3" = "y" ]; then
+   define_bool CONFIG_SOC_AU1X00 y
+   define_bool CONFIG_SOC_AU1550 y
+   define_bool CONFIG_SOC_AU1X00_32KHZ n
+   define_bool CONFIG_NONCOHERENT_IO y
+   define_bool CONFIG_PC_KEYB y
+fi
 if [ "$CONFIG_MIPS_DB1200" = "y" ]; then
    define_bool CONFIG_SOC_AU1X00 y
    define_bool CONFIG_SOC_AU1200 y
@@ -770,6 +778,7 @@
      "$CONFIG_MIPS_DB1500" = "y" -o \
      "$CONFIG_MIPS_DB1550" = "y" -o \
      "$CONFIG_MIPS_DB1200" = "y" -o \
+     "$CONFIG_MIPS_I3_MMB3" = "y" -o \
      "$CONFIG_NEC_OSPREY" = "y" -o \
      "$CONFIG_NEC_EAGLE" = "y" -o \
      "$CONFIG_NINO" = "y" -o \
diff -x asm -Naur linux-2.4.30-orig/arch/mips/ramdisk/Makefile linux-2.4.30/arch/mips/ramdisk/Makefile
--- linux-2.4.30-orig/arch/mips/ramdisk/Makefile	2005-05-12 17:57:08.000000000 +0200
+++ linux-2.4.30/arch/mips/ramdisk/Makefile	2006-12-11 18:18:37.000000000 +0100
@@ -10,6 +10,6 @@
 img = $(CONFIG_EMBEDDED_RAMDISK_IMAGE)
 ramdisk.o: $(subst ",,$(img)) ld.script
 	echo "O_FORMAT:  " $(O_FORMAT)
-	$(LD) $(LDFLAGS) -T ld.script -b binary --oformat $(O_FORMAT) -o $@ $(img)
+	$(LD) -T ld.script -b binary --oformat $(O_FORMAT) -o $@ $(img)
 
 include $(TOPDIR)/Rules.make
diff -x asm -Naur linux-2.4.30-orig/drivers/char/Config.in linux-2.4.30/drivers/char/Config.in
--- linux-2.4.30-orig/drivers/char/Config.in	2005-05-12 17:57:19.000000000 +0200
+++ linux-2.4.30/drivers/char/Config.in	2006-12-11 18:18:37.000000000 +0100
@@ -393,7 +393,7 @@
 if [ "$CONFIG_SOC_AU1X00" = "y" ]; then
    tristate ' Alchemy Au1x00 GPIO device support' CONFIG_AU1X00_GPIO
    tristate ' Au1000/ADS7846 touchscreen support' CONFIG_TS_AU1X00_ADS7846
-   #tristate ' Alchemy Au1550 PSC SPI support' CONFIG_AU1550_PSC_SPI
+   tristate ' Alchemy Au1550 PSC SPI support' CONFIG_AU1550_PSC_SPI
 fi
 if [ "$CONFIG_MIPS_ITE8172" = "y" ]; then
   tristate ' ITE GPIO' CONFIG_ITE_GPIO
